Index: /trunk/src/org/expeditee/items/MagneticConstraint/Actions/RepelTextDownAction.java
===================================================================
--- /trunk/src/org/expeditee/items/MagneticConstraint/Actions/RepelTextDownAction.java	(revision 1101)
+++ /trunk/src/org/expeditee/items/MagneticConstraint/Actions/RepelTextDownAction.java	(revision 1102)
@@ -1,7 +1,6 @@
 package org.expeditee.items.MagneticConstraint.Actions;
 
-import java.awt.Point;
-
-import org.expeditee.gui.DisplayIO;
+import org.expeditee.core.Point;
+import org.expeditee.gui.DisplayController;
 import org.expeditee.gui.FrameIO;
 import org.expeditee.gui.FrameUtils;
@@ -28,5 +27,5 @@
 				(FrameUtils.getCurrentItem().getPosition().equals(item.getPosition()) 
 				&& remainderOfLine.size() > 0 
-				&& TextLogic.XIsTowardsRight(DisplayIO.getMouseX(), (Text) remainderOfLine.getFirst()))) {
+				&& TextLogic.XIsTowardsRight(DisplayController.getMouseX(), (Text) remainderOfLine.getFirst()))) {
 			remainderOfLine.removeFirst();
 		}
@@ -42,15 +41,15 @@
 		if(!remainderOfLine.isEmpty() && currentParagraph.contains(nextLine) && MergeSameLineParagraphCollisions) { 
 			nextLine.prependLine(remainderOfLine);
-			DisplayIO.setTextCursor((Text) remainderOfLine.getFirst(), Text.HOME);
+			DisplayController.setTextCursor((Text) remainderOfLine.getFirst(), Text.HOME);
 			callback(remainderOfLine.getFirst());
 			FrameIO.SaveFrame(remainderOfLine.getLast().getParent());
 		} else if(!remainderOfLine.isEmpty()) {
 			newLineAt = currentParagraph.split(currentLine);
-			final Point first = remainderOfLine.getBoundingBox().getLocation();
+			final Point first = remainderOfLine.getBoundingBox().getTopLeft();
 			for(final Item token : remainderOfLine) {
 				double newX = token.getX() - first.getX() + newLineAt.getX();
 				token.setPosition((float) newX, (float) newLineAt.getY());
 			}
-			DisplayIO.setTextCursor((Text) remainderOfLine.getFirst(), Text.HOME);
+			DisplayController.setTextCursor((Text) remainderOfLine.getFirst(), Text.HOME);
 			callback(remainderOfLine.getFirst());
 			FrameIO.SaveFrame(remainderOfLine.getLast().getParent());
@@ -58,5 +57,5 @@
 				//3a No. Move the cursor
 			newLineAt = currentParagraph.split(currentLine);
-			DisplayIO.setCursorPosition(newLineAt);
+			DisplayController.setCursorPosition(newLineAt);
 		}
 		
Index: /trunk/src/org/expeditee/items/MagneticConstraint/Actions/UpALineAction.java
===================================================================
--- /trunk/src/org/expeditee/items/MagneticConstraint/Actions/UpALineAction.java	(revision 1101)
+++ /trunk/src/org/expeditee/items/MagneticConstraint/Actions/UpALineAction.java	(revision 1102)
@@ -1,5 +1,5 @@
 package org.expeditee.items.MagneticConstraint.Actions;
 
-import org.expeditee.gui.DisplayIO;
+import org.expeditee.gui.DisplayController;
 import org.expeditee.items.Item;
 import org.expeditee.items.Text;
@@ -19,5 +19,5 @@
 		final int lastLineLength = 
 				lastLine.get(lastLine.size() - 1).getX() + lastLine.get(lastLine.size() - 1).getBoundsWidth() - lastLine.get(0).getX();
-		final int distanceThroughCurrentLine = DisplayIO.getMouseX() - startOfThisLine.getX();
+		final int distanceThroughCurrentLine = DisplayController.getMouseX() - startOfThisLine.getX();
 		if(distanceThroughCurrentLine <= lastLineLength) {
 			Item above = lastLine.get(0);
@@ -37,6 +37,6 @@
 		if(toMoveTo instanceof Text) {
 			final Text asText = (Text) toMoveTo;
-			DisplayIO.setTextCursor(asText, Text.END);
-		} else DisplayIO.setCursorPosition(toMoveTo.getPosition(), false);
+			DisplayController.setTextCursor(asText, Text.END);
+		} else DisplayController.setCursorPosition(toMoveTo.getPosition(), false);
 		return true;
 	}
Index: /trunk/src/org/expeditee/items/MagneticConstraint/Actions/VerticalTabAction.java
===================================================================
--- /trunk/src/org/expeditee/items/MagneticConstraint/Actions/VerticalTabAction.java	(revision 1101)
+++ /trunk/src/org/expeditee/items/MagneticConstraint/Actions/VerticalTabAction.java	(revision 1102)
@@ -1,6 +1,6 @@
 package org.expeditee.items.MagneticConstraint.Actions;
 
-import org.expeditee.gui.Browser;
-import org.expeditee.gui.DisplayIO;
+import org.expeditee.gio.EcosystemManager;
+import org.expeditee.gui.DisplayController;
 import org.expeditee.items.Item;
 import org.expeditee.items.MagneticConstraint.MagneticConstraintAction;
@@ -12,5 +12,5 @@
 	public boolean exec(final Item item) {
 		if(item.getParent() == null || !this.isSpIDERCodePage(item.getParent())) return false;
-		final int tabWidth = Browser._theBrowser.getFontMetrics(Browser._theBrowser.getFont()).stringWidth("          ");
+		final int tabWidth = EcosystemManager.getTextLayoutManager().getStringWidth(null, "     ");
 		tab(item, tabWidth);
 		return true;
@@ -20,5 +20,5 @@
 	public boolean invert(Item item) {
 		if(item.getParent() == null || !this.isSpIDERCodePage(item.getParent())) return false;
-		final int tabWidth = -(Browser._theBrowser.getFontMetrics(Browser._theBrowser.getFont()).stringWidth("     "));
+		final int tabWidth = -(EcosystemManager.getTextLayoutManager().getStringWidth(null, "     "));
 		tab(item, tabWidth);
 		return true;
@@ -27,10 +27,10 @@
 	private void tab(final Item item, final int tabWidth) {
 		if(item == null) {
-			DisplayIO.setCursorPosition(DisplayIO.getMouseX() + tabWidth, DisplayIO.getMouseY());
+			DisplayController.setCursorPosition(DisplayController.getMouseX() + tabWidth, DisplayController.getMouseY());
 		} else {
 			final Line postTabLine = Line.getLineFromToken(item);
 			postTabLine.deltaX(tabWidth);
 			if(postTabLine.size() > 0)
-				DisplayIO.setCursorPosition(postTabLine.get(0).getPosition());
+				DisplayController.setCursorPosition(postTabLine.get(0).getPosition());
 		}
 	}
Index: /trunk/src/org/expeditee/items/MagneticConstraint/Utilities/BoxLogic.java
===================================================================
--- /trunk/src/org/expeditee/items/MagneticConstraint/Utilities/BoxLogic.java	(revision 1101)
+++ /trunk/src/org/expeditee/items/MagneticConstraint/Utilities/BoxLogic.java	(revision 1102)
@@ -1,9 +1,9 @@
 package org.expeditee.items.MagneticConstraint.Utilities;
 
-import java.awt.Rectangle;
 import java.util.Collection;
 import java.util.LinkedList;
 import java.util.List;
 
+import org.expeditee.core.bounds.AxisAlignedBoxBounds;
 import org.expeditee.gui.Frame;
 import org.expeditee.items.Dot;
@@ -40,9 +40,9 @@
 			final int bottomPos = Math.max(canditate.getStartItem().getY(),
 					canditate.getEndItem().getY());
-			final Rectangle itemHitBox = item.getArea().getBounds();
-			if (topPos < itemHitBox.getY() && bottomPos > itemHitBox.getY()) {
-				if (itemHitBox.getX() + itemHitBox.getWidth() > canditate
-						.getStartItem().getX()
-						&& itemHitBox.getX() < canditate.getStartItem().getX()) {
+			final AxisAlignedBoxBounds itemHitBox = item.getBoundingBox();
+			if (topPos < itemHitBox.getMinY() && bottomPos > itemHitBox.getMinY()) {
+				if (itemHitBox.getMinX() + itemHitBox.getWidth() > canditate.getStartItem().getX() &&
+						itemHitBox.getMinX() < canditate.getStartItem().getX())
+				{
 					return true;
 				}
Index: /trunk/src/org/expeditee/items/MagneticConstraint/Utilities/Line.java
===================================================================
--- /trunk/src/org/expeditee/items/MagneticConstraint/Utilities/Line.java	(revision 1101)
+++ /trunk/src/org/expeditee/items/MagneticConstraint/Utilities/Line.java	(revision 1102)
@@ -1,7 +1,7 @@
 package org.expeditee.items.MagneticConstraint.Utilities;
 
-import java.awt.Rectangle;
 import java.util.LinkedList;
 
+import org.expeditee.core.bounds.AxisAlignedBoxBounds;
 import org.expeditee.items.Item;
 
@@ -18,6 +18,6 @@
 	
 	public Line prependLine(final Line line) {
-		final int x = this.getBoundingBox().x;
-		final int width = line.getBoundingBox().width;
+		final int x = this.getBoundingBox().getMinX();
+		final int width = line.getBoundingBox().getWidth();
 		this.deltaX(width);
 		line.setX(x);
@@ -27,6 +27,6 @@
 	
 	public Line appendLine(final Line line) {
-		final int x = this.getBoundingBox().x;
-		final int width = this.getBoundingBox().width;
+		final int x = this.getBoundingBox().getMinX();
+		final int width = this.getBoundingBox().getWidth();
 		line.setX(x + width);
 		line.setY(this.getFirst().getY());
@@ -83,12 +83,12 @@
 	}
 	
-	public Rectangle getBoundingBox() {
+	public AxisAlignedBoxBounds getBoundingBox() {
 //		final Rectangle rect = new Rectangle(this.getFirst().getX(), this.getFirst().getY(), this.getFirst().getBoundsWidth(), this.getFirst().getBoundsHeight());
 //		for(final Item token : this) 
 //			rect.add(new Rectangle(token.getX(), token.getY(), token.getBoundsWidth(), token.getBoundsHeight()));
 //		return rect;
-		final Rectangle rect = this.getFirst().getArea().getBounds();
+		final AxisAlignedBoxBounds rect = this.getFirst().getBoundingBox();
 		for(final Item token : this)
-			rect.add(token.getArea().getBounds());
+			rect.combineWith(token.getBoundingBox());
 		return rect;
 	}
Index: /trunk/src/org/expeditee/items/MagneticConstraint/Utilities/Paragraph.java
===================================================================
--- /trunk/src/org/expeditee/items/MagneticConstraint/Utilities/Paragraph.java	(revision 1101)
+++ /trunk/src/org/expeditee/items/MagneticConstraint/Utilities/Paragraph.java	(revision 1102)
@@ -1,6 +1,8 @@
 package org.expeditee.items.MagneticConstraint.Utilities;
 
-import java.awt.*;
 import java.util.LinkedList;
+
+import org.expeditee.core.Point;
+import org.expeditee.core.bounds.AxisAlignedBoxBounds;
 import org.expeditee.items.Text;
 
@@ -30,7 +32,10 @@
 	}
 	
-	public Rectangle getBoundingBox() {
-		final Rectangle rect = new Rectangle();
-		for(final Line ln : this) rect.add(ln.getBoundingBox());
+	public AxisAlignedBoxBounds getBoundingBox() {
+		AxisAlignedBoxBounds rect = null;
+		for(final Line ln : this) {
+			if (rect == null) rect = ln.getBoundingBox();
+			else rect.combineWith(ln.getBoundingBox());
+		}
 		return rect;
 	}
@@ -50,6 +55,6 @@
 		if(nextLine == null) {
 			//2a. No; then we simply need to calculate the position of where it would be and return that.
-			final Rectangle boundingBox = splitAt.getBoundingBox();
-			return new Point((int)boundingBox.getX(), (int)boundingBox.getMaxY() + lineHeight);
+			final AxisAlignedBoxBounds boundingBox = splitAt.getBoundingBox();
+			return new Point((int)boundingBox.getMinX(), (int)boundingBox.getMaxY() + lineHeight);
 		}
 		//3. Get paragraph starting from the next line
@@ -58,5 +63,5 @@
 		if(!this.containsAll(paragraphStartingAtNextLine)) {
 			//4b. No; then we simply need to calculate the position of the next line and return that.
-			final Rectangle boundingBox = splitAt.getBoundingBox();
+			final AxisAlignedBoxBounds boundingBox = splitAt.getBoundingBox();
 			return new Point(((Text) splitAt.getFirst()).getX(), (int)boundingBox.getMaxY() + lineHeight);
 		} 
@@ -66,5 +71,5 @@
 		//6. Return the position of the new line we have made space for.
 		
-		final Rectangle boundingBox = splitAt.getBoundingBox();
+		final AxisAlignedBoxBounds boundingBox = splitAt.getBoundingBox();
 		final int x = ((Text) splitAt.getFirst()).getX();
 		return new Point(x, (int)boundingBox.getMaxY() + lineHeight);
@@ -72,5 +77,5 @@
 	
 	private static int getLineHeight(final Line line) {
-		return (int) (line.get(0).getArea().getBounds().getHeight() * 1.2);
+		return (int) (line.get(0).getBoundingBox().getHeight() * 1.2);
 	}
 	
@@ -89,9 +94,9 @@
 	private static boolean isInSameParagraph(final Line thisLine, final Line nextLine, final int lineHeight) {
 		if(!XGroupLogic.areInSameXGroup(thisLine.get(0), nextLine.get(0))) return false;
-		final Rectangle thisLineBoundingBox = thisLine.getBoundingBox();
-		final Rectangle nextLineBoundingBox = nextLine.getBoundingBox();
-		final Point toAdd = new Point(Math.min((int)thisLineBoundingBox.getX(),(int) nextLineBoundingBox.getX()), (int)thisLineBoundingBox.getMaxY() + lineHeight);
-		final Rectangle overlappingSection = new Rectangle(thisLineBoundingBox);
-		overlappingSection.add(toAdd);
+		final AxisAlignedBoxBounds thisLineBoundingBox = thisLine.getBoundingBox();
+		final AxisAlignedBoxBounds nextLineBoundingBox = nextLine.getBoundingBox();
+		final Point toAdd = new Point(Math.min((int)thisLineBoundingBox.getMinX(),(int) nextLineBoundingBox.getMinX()), (int)thisLineBoundingBox.getMaxY() + lineHeight);
+		final AxisAlignedBoxBounds overlappingSection = new AxisAlignedBoxBounds(thisLineBoundingBox);
+		overlappingSection.combineWith(toAdd);
 		return overlappingSection.intersects(nextLineBoundingBox);
 	}
Index: /trunk/src/org/expeditee/items/MagneticConstraint/Utilities/TextLogic.java
===================================================================
--- /trunk/src/org/expeditee/items/MagneticConstraint/Utilities/TextLogic.java	(revision 1101)
+++ /trunk/src/org/expeditee/items/MagneticConstraint/Utilities/TextLogic.java	(revision 1102)
@@ -1,6 +1,6 @@
 package org.expeditee.items.MagneticConstraint.Utilities;
 
-import org.expeditee.gui.Browser;
-import org.expeditee.gui.DisplayIO;
+import org.expeditee.gio.EcosystemManager;
+import org.expeditee.gui.DisplayController;
 import org.expeditee.items.Text;
 
@@ -9,5 +9,5 @@
 	public static boolean XIsTowardsRight(final int x, final Text text) {
 		if(text.getPixelBoundsUnion() == null) return false;
-		final double distanceThroughText = x - text.getPixelBoundsUnion().getX();
+		final double distanceThroughText = x - text.getPixelBoundsUnion().getMinX();
 		return /*text.getText().length() == 1 ||*/ distanceThroughText > (text.getPixelBoundsUnion().getWidth() / 2);
 	}
@@ -15,5 +15,5 @@
 	public static boolean XIsTowardsLeft(final Text text, final int x) {
 		if(text.getPixelBoundsUnion() == null) return false;
-		final double distanceThroughText = x - text.getPixelBoundsUnion().getX();
+		final double distanceThroughText = x - text.getPixelBoundsUnion().getMinX();
 		return distanceThroughText < (text.getPixelBoundsUnion().getWidth() / 2);
 	}
@@ -21,6 +21,6 @@
 	public static boolean XIsBeforeCharacters(final Text text, final int x) {
 		try {
-			final int firstLetterWidth = Browser._theBrowser.getFontMetrics(Browser._theBrowser.getFont()).stringWidth(text.getText().substring(0, 1));
-			final double distanceThroughText = x - text.getPixelBoundsUnion().getX();
+			final int firstLetterWidth = EcosystemManager.getTextLayoutManager().getStringWidth(null, text.getText().substring(0, 1));
+			final double distanceThroughText = x - text.getPixelBoundsUnion().getMinX();
 			return firstLetterWidth > distanceThroughText;
 		} catch (NullPointerException e) {
@@ -33,5 +33,5 @@
 	public static boolean XIsAfterCharacters(final Text text, final int x) {
 		try {
-			final double distanceThroughText = x - text.getPixelBoundsUnion().getX();
+			final double distanceThroughText = x - text.getPixelBoundsUnion().getMinX();
 			return distanceThroughText > text.getPixelBoundsUnion().getWidth();
 		} catch (NullPointerException e) {
@@ -41,5 +41,5 @@
 	
 	public static int GetInsertionIndexSelected(final Text text) {
-		return text.getCharPosition(0, DisplayIO.getMouseX()).getInsertionIndex();
+		return text.getCharPosition(0, DisplayController.getMouseX()).getInsertionIndex();
 	}
 }
